# ==========================================
# General-purpose view Makefile
# Author:  Mohammad Maysami
#          SEP, Stanford University
#          August 08
# ==========================================
dn= >/dev/null


# ==========================================
# ======     Default view rules      =======
# ==========================================
%.graph: %
	Graph <$< | Tube
%.grey: %
	Grey <$* | Tube

%.black: %
	Grey <$* newclip=1 wantscalebar=1 | Tube

%.HV: %
	Grey bpclip=1 epclip=99 newclip=1 <$< out=$@  $(dn)

%.tube: %
	tube $*



# ==========================================
# ======         No Clipping         =======
# ==========================================
%.grey0: %
	Transp <$* pclip=100 wantscalebar=1| Grey | Tube

%.black0: %
	Grey <$* newclip=1 bpclip=0 epclip=100 wantscalebar=1| Tube


# ==========================================
# ======         1%  Clipping        =======
# ==========================================
%.grey1: %
	Transp <$* pclip=99 wantscalebar=1| Grey | Tube
%.black1: %
	Grey <$* newclip=1 bpclip=1 epclip=99 wantscalebar=1| Tube
%.color1: %
	Grey <$* newclip=1 bpclip=1 epclip=99 wantscalebar=1 color=j| Tube



# ==========================================
#  Create PDF and PS (pstexpen or vplot2eps)
# ==========================================
%.ps: %.v
	pstexpen   ${R}/$*.v  ${R}/$*.ps fat=5 famult=7 invras=y color=y scale=0.9
	#vplot2eps fat=5 invras=y ${R}/$<  ${R}/$*.eps
	# Other options:   big=y force=n

%.pdf: %.ps
	epstopdf ${R}/$<

%.gif: ${R}/%.v
	vplot2gif ${R}/$<




# $R/%.ps: $R/%.v 
# 	pstexpen   $R/$*.v  ${R}/$*.ps fat=5 famult=7 invras=y color=y scale=0.9
# 	#vplot2eps fat=5 invras=y $R/$*.v  ${R}/$*.eps
# 	# Other options:   big=y force=n

# $R/%.pdf: $R/%.ps
# 	epstopdf $<

# $R/%.gif: ${R}/%.v
# 	vplot2gif $<


# ==========================================
# ======     View  and  Burn         =======
# ==========================================
%.view: ${R}/%.v
	tube $<  &

%.burn: ${R}/%.v
	rm $<

%.burnview: %.burn
	make $*.view



# ==========================================
#            Other Misc. rules
# ==========================================
paper.pdf: paper.tex
	scons paper.pdf

view: clean paper.pdf
	kpdf paper.pdf


# ER_burn:  remove figures
# ER_build: build figures

# burn: clean
# 	Rm -f ./*.H*
# 	rm -f ${B}/*;
# 	rm -f ${R}/*;
# # 	rm -f *.pdf *.log *.dvi *.aux *.ltx


clean: jclean
