! Reflectivity from impedance
!
! Z2-Z1/(Z1+Z2)
!
! Author:  Mohammad Maysami
!          SEP, Stanford University
!          May 09

program reflect

use sep 
use causint

implicit none
real,allocatable  :: data(:,:),ref(:,:)
integer           :: nz,nx,i,j
real              :: dx,dz
logical           :: stat,adj,add

call sep_init(SOURCE)

call from_par("adj",adj,.false.)
call from_par("add",add,.false.)

call from_history("n1",nz)
call from_history("n2",nx)

allocate( data(nz,nx), ref(nz,nx))
call sep_read(data)

do j=1,nx
   do i=1,nz
      ref(i,j)= (data(i+1,j)-data(i,j)) / (data(i+1,j)+data(i,j))
   end do
end do


call sep_write(ref)
call sep_close

end program
