module tomo_reg_prec_mod
use sep
use nhelicon2
use npolydiv2
use nhelicon
use tomo_eps_mod
use npolydiv
use helicon
use chain_mod
use sep3d_struct_mod
use io_nfilt
use xgrad_mod

implicit none
logical, private, save :: prec,dual,new,xflag
real, private,save,pointer :: space(:),space2(:)
type(nfilter) :: filt1_prec,filt2_prec
type(nfilter) :: filt1_reg,filt2_reg,filta,filtb
type(filter) :: filt1
integer, private, save :: nmod



contains

! --------------------------------------
logical function load_reg_prec(slow_s,reg0) 
  ! logical function load_reg_prec(slow_s,slow,reg0,aux) 
  ! real              :: slow(:)
  type(sep3d)   :: slow_s,reg_s,aux_s		      
  real   , pointer  :: reg0(:) ,junk(:),aux(:),xaux0(:)
  integer, external :: auxin,sreed
  integer :: ierr
  integer :: i
  integer :: ns
  real :: sm
  
  load_reg_prec=.false.
  
  call from_param("new",new,.true.)
  call from_param("prec",prec,.true.)
  call from_param("xflag",xflag,.false.)
  write (0,*), "==== TOMO NEW FLAG:",new
  write (0,*), "==== TOMO PREC FLAG:",prec
  write (0,*), "==== TOMO XG   FLAG:",xflag

  nmod=product(slow_s%n(1:sep3d_ndims(slow_s)))
  allocate(reg0(nmod))


  if (xflag) then

     ! Set and Read AUX Soft-data
     ! ==========================
     allocate(aux(nmod))
     
     if(-1==auxin("aux")) then
        write (0,*) " aux tag is not provided. Initialization failed !"
        return
     else
        call init_sep3d("aux",aux_s,"INPUT")
        if(product(aux_s%n) /= size(aux)) then
           write(0,*) "Size of aux and the slowness space must be equal !"
           return
        end if
        
        
        if(4*size(aux)/=sreed("aux",aux,size(aux)*4)) then
           write(0,*) "Trouble reading in aux !"
           return
        end if
        
     end if
     call xgrad_init(aux_s,aux)



     !       XAUX0 Part
     ! ==========================
     allocate(xaux0(nmod))

     if(-1==auxin("xaux0")) then
        xaux0=0.
        ! write (0,*) "Tomo_REG: Xaux0 computed by xgrad."
        ! call xgrad_init(aux_s,aux)
        ! ierr=xgrad_lop (.false.,.false.,slow,xaux0)
        ! xaux0=-xaux0
     else
        call init_sep3d("xaux0",aux_s,"INPUT")
        if(product(aux_s%n) /= size(xaux0)) then
           write(0,*) "Size of xaux0 and the slowness space must be equal !"
           return
        end if
        
        if(4*size(xaux0)/=sreed("xaux0",xaux0,size(xaux0)*4)) then
           write(0,*) "trouble reading in xaux0"
           return
        end if
        ! call sep3d_write_description("check_xaux0.H",aux_s)
        ! call srite("check_xaux0.H",xaux0,size(xaux0)*4)
        xaux0=-xaux0 ! XG(s0+ds)=0 ==> XG.ds= -XG.s0
     end if
	
     call sep3d_write_description("check_xaux0.H",aux_s)
     call srite("check_xaux0.H",xaux0,size(xaux0)*4)
 end if  !! XFLAG END
!!! else  ! XFLAG=FALSE 





     !       REG0 Part
     ! ==========================
     if(-1==auxin("reg0")) then
        reg0=0.

     else
        call init_sep3d("reg0",reg_s,"INPUT")
        if(product(reg_s%n) /= size(reg0)) then
           write(0,*) "Size of reg0 and the slowness space must be equal !"
           return
        end if
    		
        if(4*size(reg0)/=sreed("reg0",reg0,size(reg0)*4)) then
           write(0,*) "trouble reading in reg0"
           return
        end if
        ! call sep3d_write_description("check_reg0.H",reg_s)
        ! call srite("check_reg0.H",reg0,size(reg0)*4)
        
        reg0=-reg0


        ns=0; sm=0
        do i=1,size(reg0)
           if(abs(reg0(i)) <.3.and. i < 200) then
              sm=sm+reg0(i)
              ns=ns+1
           end if
        end do
        
        sm=sm/ns
        ! sm=.06
        
        do i=1,size(reg0)
           if(abs(reg0(i)) <.3 .and. i < 200) then
              reg0(i)=reg0(i)-sm
              ! write(0,*) "SUBTA",reg0(i),sm
           else
              reg0(i)=0
           end if
        end do
		
        ! write(0,*) "CHECK SM",sm,maxval(reg0),minval(reg0)
     end if
	
     call sep3d_write_description("check_reg0.H",reg_s)
     call srite("check_reg0.H",reg0,size(reg0)*4)


     !  ==== REGULARIZATION Part 1 ====
     if(0==auxin("filt_reg")) then
        write(0,*) "filt not supplied"
        return
     end if
     
     if(.not. read_nfilt("filt_reg",filt1_reg)) then
        write(0,*) "trouble reading nfilter"
        return
     end if
	
     dual=.false.
     if(-1/=auxin("filt2_reg")) then
        dual=.true.
        if(.not. read_nfilt("filt2_reg",filt2_reg)) then
           write(0,*) "trouble reading nfilter"
           return
        end if
        ! allocate(space(nmod))
        
     end if

     ! --- NEW FLAG ---
     if (new) then
        if(.not. read_nfilt("filt1",filtb)) then
           write(0,*) "trouble reading nfilter"
           return
        end if
        
        if(.not. read_nfilt("filt2",filta)) then
           write(0,*) "trouble reading nfilter"
           return
        end if
     end if
!!!!   end if  ! XFLAG END

     allocate(space(nmod),space2(nmod))


  !  ==== REGULARIZATION Part 2 ====
  call allocatehelix(filt1,3)
  ierr=slow_s%n(1)
  filt1%lag=(/ierr-1,ierr,ierr/)
  filt1%flt=(/-.33,-.33,-.33/)
  call helicon_init(filt1)
  
  ! --- FALSE NEW FLAG ---
  if(.not. new) then
     call nhelicon_init(filt1_reg)
     if(dual) call nhelicon2_init(filt2_reg)
     
     if(prec) then
        call npolydiv_init(nmod,filt1_prec)
        if(dual) call npolydiv2_init(nmod,filt2_prec)
     end if
  else
     call npolydiv_init(nmod,filta)
     call nhelicon_init(filtb)
  end if
  

  !     PRE-Cond. Part
  ! ==========================
  if(prec) then
     if(.not. read_nfilt("filt_prec",filt1_prec)) then
        write(0,*) "trouble reading nfilter"
        return
     end if
     
     dual=.false.
     if(-1/=auxin("filt2_prec")) then
        dual=.true.
        if(.not. read_nfilt("filt2_prec",filt2_prec)) then
           write(0,*) "trouble reading nfilter"
           return
        end if
        !   allocate(space(nmod))
     end if
  end if


  !allocate(junk(size(reg0)))
  !junk=reg0
  !ierr=eps_op(.false.,.false.,junk,reg0)
  !deallocate(junk)
  !reg0=0.

  if (xflag) reg0=xaux0
  load_reg_prec=.true.
end function 


! --------------------------------------
integer function reg_op(adj,add,model,data)
  logical, intent(in) :: adj,add
  real :: model(:),data(:)
  integer :: ierr
  
  reg_op=0;
  call from_param("xflag",xflag,.false.)

  if (xflag) then
     ierr=xgrad_lop (adj,add,model,data)
     ! write(0,*) "REG_OP: XGRAD is used"

  else
     ! write(0,*) "REG_OP: REG is used"
     if(new) then
        !write(0,*) "in reg",adj
        ! call chain(nhelicon_lop,prec_op,adj,add,model,data,space2)
        ierr=nhelicon_lop(adj,add,model,data)
     else
        if(dual) then
           call chain(nhelicon_lop,nhelicon2_lop,adj,add,model,data,space)
        else
           ierr=nhelicon_lop(adj,add,model,data)
           ! ierr=helicon_lop(adj,add,model,data)
        end if
     end if
  end if
end function reg_op



! --------------------------------------
integer function prec_op(adj,add,model,data)
  logical, intent(in) :: adj,add
  real :: model(:),data(:)
  prec_op=0

  ! ---NEW FLAG---
  if(new) then
     !call chain(npolydiv_lop,nhelicon_lop,adj,add,model,data,space)
     ! call adjnull(adj,add,model,data)
     if(1==1) then
        prec_op=npolydiv_lop(adj,add,model,data)
     endif
     
     !write(0,*) "BB",adj
     if(1==2) then
        if(.not. adj) then
           data=model+data
        else
           model=data+model
        end if
     end if
  else
     if (prec) then
        if(dual) then
           call chain(npolydiv_lop,npolydiv2_lop,adj,add,model,data,space)
        else
           prec_op=npolydiv_lop(adj,add,model,data)
        end if
     else 
        if(.not. adj) then
           data=model+data
        else
           model=data+model
        end if
     end if
  end if
end function prec_op

  

! --------------------------------------
integer function reg_range()
  reg_range=nmod
end function

integer function reg_domain()
  reg_domain=nmod
end function

integer function prec_range()
  prec_range=nmod
end function

integer function prec_domain()
  prec_domain=nmod
end function


! --------------------------------------

end module
