program tomo_op
use sep
use sep3d_struct_mod
use basic_util_mod
use tomo_inverse_mod
implicit none
type(sep3d)       ::  slow_s
integer           :: n(3)
integer,external  :: sreed,srite
real              :: o(3),d(3)
real, allocatable :: slow(:)
real, pointer     :: err0(:),reg0(:),dat0(:)
real              :: eps,eps0,punish_eps

real, allocatable :: junk(:)

  call sep_init(SOURCE)

  ! Print out epsilons
  call from_param("eps",eps)
  call from_param("eps_0",eps0)
  call from_param("punish_eps",punish_eps)

  write(0,*) "--------------- EPSILONS ---------------"
  write(0,*) " - EPS        =",eps
  write(0,*) " - EPS_0      =",eps0
  write(0,*) " - PUNISH_EPS =",punish_eps


  ! Initialize the slowness input
  call init_sep3d("in",slow_s,"INPUT")
  call set_n_o_d_3d(slow_s,n,o,d)
  allocate(slow(product(n)))

  if(4*size(slow)/=sreed("in",slow,size(slow)*4)) &
    call seperr("trouble reading in slowness model")


  ! Load different operators

  ! Reads err0 from "err" tag
  if(.not. load_tomo_op(slow_s,err0)) &
    call seperr("trouble reading in tomo_op")

  ! load_wt_op(data) => sets Nfit=Ndat
  if(.not. load_wt_op(err0))& !done
    call seperr("trouble reading in wt operator")

  ! Simple Mask operator, read in from "model_mask" tag
  if(.not. load_mask_op(slow_s))&  !done
    call seperr("trouble initalizing mask_op")

  ! A weighting operator with Epsilon and WTS if eps_file is provided.
  if(.not. load_eps_op(slow_s))& !done
    call seperr("trouble initalizing eps_op")

  ! Regularization-Preconditioning Part
  if(.not. load_reg_prec(slow_s,reg0)) &  !done
    call seperr("trouble loading reg_prec")

  if(.not. init_chains(err0,reg0,dat0)) & !done
    call seperr("trouble initializing chains")

  !   allocate(junk(product(n)))
  !   write (0,*) " ==== SLOW NORM:",dot_product(slow,slow)

  ! Init. & Run solver
  if(.not. init_solver(slow))& !done
    call seperr("trouble initializing solver")
  if(.not. run_solver(dat0,slow)) & !done
    call seperr("trouble running solver")

  ! Write out the updated velocity
  if(4*size(slow)/=srite("out",slow,size(slow)*4)) &
    call seperr("trouble writing out slowness model")

end program
